/*
 * Daneel - Dalvik to Java bytecode compiler
 * Copyright (C) 2011  IcedRobot team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.icedrobot.daneel.util;

import static org.junit.Assert.assertEquals;

import java.nio.ByteBuffer;

import org.junit.Test;

public class BufferUtilTest {

    private static final byte[] SEQ1 = new byte[] { 0 };
    private static final byte[] SEQ2 = new byte[] { 1 };
    private static final byte[] SEQ3 = new byte[] { 127 };
    private static final byte[] SEQ4 = new byte[] { -128, 127 };

    @Test
    public void testGetULEB128() {
        assertEquals(0, BufferUtil.getULEB128(ByteBuffer.wrap(SEQ1)));
        assertEquals(1, BufferUtil.getULEB128(ByteBuffer.wrap(SEQ2)));
        assertEquals(127, BufferUtil.getULEB128(ByteBuffer.wrap(SEQ3)));
        assertEquals(16256, BufferUtil.getULEB128(ByteBuffer.wrap(SEQ4)));
    }

    @Test
    public void testGetSLEB128() {
        assertEquals(0, BufferUtil.getSLEB128(ByteBuffer.wrap(SEQ1)));
        assertEquals(1, BufferUtil.getSLEB128(ByteBuffer.wrap(SEQ2)));
        assertEquals(-1, BufferUtil.getSLEB128(ByteBuffer.wrap(SEQ3)));
        assertEquals(-128, BufferUtil.getSLEB128(ByteBuffer.wrap(SEQ4)));
    }
}
